# hello_world_thumb.s

#  assemble with     "as -o hello_world_thumb.o hello_world_thumb.s"
#  link with         "ld -o hello_world_thumb hello_world_thumb.o"

# Run "./hello_world_thumb"


# Syscalls
.equ SYSCALL_EXIT,	1
.equ SYSCALL_WRITE,	4

.equ STDOUT,		1

.thumb

        .globl _start
_start:
	mov	r0,#STDOUT		/* stdout */
	ldr	r1,=hello
	mov	r2,#13			@ length
	mov	r7,#SYSCALL_WRITE
	swi	0x0

        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
        mov     r7,#SYSCALL_EXIT	@ put exit syscall number in r7
	swi	#0x0			@ and exit


.data
hello:		.ascii "Hello World!\n"
